/*
  -------------------------------------------------------------------
  
  Copyright (C) 2006, 2007, 2008, Andrew W. Steiner
  
  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl. If not, see <http://www.gnu.org/licenses/>.

  -------------------------------------------------------------------
*/
#include "err_hnd.h"
#include "file_format.h"

using namespace std;
using namespace o2scl;

int o2scl::o2scl_make_tfile(std::string &fname, int st) {
  std::string dir=lib_settings.get_tmp_dir();
  int i=st;
  for(size_t j=0;j<10;j++) {
    int i1=i%10;
    int i2=(i/10)%10;
    int i3=(i/100)%10;
    int i4=(i/1000)%10;
    int i5=(i/10000)%10;
    char c1=i1+'0';
    char c2=i2+'0';
    char c3=i3+'0';
    char c4=i4+'0';
    char c5=i5+'0';
    std::string fn=dir+c1+c2+c3+c4+c5+"_o2scl.tmp";
    std::ofstream fout(fn.c_str());
    if (fout) {
      fout.close();
      fname=fn;
      return 0;
    }
    i+=1;
    i=i%100000;
  }
  set_err("Function o2scl_make_tfile() failed.",gsl_efailed);
  return gsl_efailed;
}
