/*
  -------------------------------------------------------------------
  
  Copyright (C) 2006, 2007, 2008, Andrew W. Steiner
  
  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl. If not, see <http://www.gnu.org/licenses/>.

  -------------------------------------------------------------------
*/

#include <o2scl/test_mgr.h>
//#include <o2scl/text_file.h>
#include <o2scl/text_file.h>

using namespace std;
using namespace o2scl;

int main(void) {
  test_mgr t;
  t.set_output_level(2);

  text_out_file tof(&cout);

  for(int i=0;i<2000;i+=100) {
    tof.int_out(i);
  }
  tof.end_line();
  tof.word_out("string");
  tof.word_out("s");
  tof.string_out("This is a string  test");
  tof.end_line();

  std::string r="This is a test without brackets.";
  std::string r2=tof.reformat_string(r);
  t.test_str(r,r2,"no brackets");

  std::string s="This is a string with < brackets >.";
  std::string s2=tof.reformat_string(s);
  std::string s3="This is a string with << brackets >>.";
  t.test_str(s2,s3,"with brackets");

  int ir=o2scl_make_tfile(s);
  cout << ir << endl;
  ofstream fout(s.c_str());
  fout << "test." << endl;
  fout.close();
  
  t.report();

  return 0;
}
