/*
  -------------------------------------------------------------------
  
  Copyright (C) 2006, 2007, 2008, Andrew W. Steiner
  
  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl. If not, see <http://www.gnu.org/licenses/>.

  -------------------------------------------------------------------
*/

#include <o2scl/funct.h>
#include <o2scl/gsl_inte_qawo.h>

using namespace std;
using namespace o2scl;

double testfun(double tx, void *&pa);

funct_fptr_noerr<void *> tf(testfun);

double testfun(double x, void *&pa) {
  return x;
}

int main(void) {
  double a=3.0, calc, exact, diff;
  gsl_inte_qawo_sin<void *,funct_fptr_noerr<void *> > cs;
  gsl_inte_qawo_cos<void *,funct_fptr_noerr<void *> > cc;
  test_mgr t;
  t.set_output_level(2);
  void *vp=NULL;

  cout.setf(ios::scientific);
  cout.precision(10);
  
  calc=cs.integ(tf,0.0,1.0,vp);
  t.test_rel(calc,0.301169,1.0e-5,"gsl_inte_qawo 2");
  
  calc=cc.integ(tf,0.0,1.0,vp);
  t.test_rel(calc,0.381773,1.0e-5,"gsl_inte_qawo 1");
  
  t.report();
  return 0;
}

