/*
  -------------------------------------------------------------------
  
  Copyright (C) 2006, 2007, 2008, Andrew W. Steiner
  
  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl. If not, see <http://www.gnu.org/licenses/>.

  -------------------------------------------------------------------
*/
#ifndef O2SCL_OTHER_IOC_H
#define O2SCL_OTHER_IOC_H
#include <string>
#include <o2scl/base_ioc.h>
#include <o2scl/other_ioc.h>
#include <o2scl/gsl_series.h>

#ifndef DOXYGENP
namespace o2scl {
#endif

  /** \brief Setup I/O for series acceleration
  */
  class other_ioc {
    
  public:

    other_ioc() {
      gsl_series_io=new gsl_series_io_type
	("gsl_series_io");
    }

    ~other_ioc() {
      delete gsl_series_io;
    }

    gsl_series_io_type *gsl_series_io;
    
  protected:

#ifndef DOXYGENP

    base_ioc b;

#endif
  
  };

#ifndef DOXYGENP
}
#endif

#endif
