/*
  -------------------------------------------------------------------
  
  Copyright (C) 2006, 2007, 2008, Andrew W. Steiner
  
  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl. If not, see <http://www.gnu.org/licenses/>.

  -------------------------------------------------------------------
*/
#include <o2scl/deriv_part.h>
#include <o2scl/test_mgr.h>

using namespace std;
using namespace o2scl;

int main(void) {
  int ret;
  test_mgr t;
  t.set_output_level(2);

  cout.setf(ios::scientific);

  deriv_fermion e(1.0,2.0);
  t.test_rel(e.m,1.0,1.0e-6,"mass inheritance");

  deriv_classical e2(1.0,2.0);
  t.test_rel(e2.m,1.0,1.0e-6,"mass inheritance");

  t.report();
  return 0;
}


