/*
  -------------------------------------------------------------------
  
  Copyright (C) 2006, 2007, 2008, Andrew W. Steiner
  
  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl. If not, see <http://www.gnu.org/licenses/>.

  -------------------------------------------------------------------
*/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <o2scl/gaussian_2d.h>

using namespace std;
using namespace o2scl;

#include <o2scl/test_mgr.h>
#include <o2scl/gsl_rnga.h>

inline int nint(double x) {
  if (x<0.0) return ((int)(x-0.5));
  else return ((int)(x+0.5));
}

int main(void) {
  test_mgr t;
  t.set_output_level(2);

  gaussian_2d<gsl_rnga> r;
  double x, y;
  
  int bins[19];
  for(int i=0;i<19;i++) bins[i]=0;
  
  // Generate a set of random numbers and bin them
  // ignoring the tails.

  for(int i=0;i<1000;i++) {
    r.random(1.0,x,y);
    
    int ix=nint(x*5.0)+9;
    if (ix>=0 && ix<19) bins[ix]++;
    
    int iy=nint(y*5.0)+9;
    if (iy>=0 && iy<19) bins[iy]++;
  }

  // Print out the distribution
  for(int i=0;i<19;i++) {
    cout << i << " " << bins[i] << endl;
  }
    
  t.report();
  return 0;
}


